\documentclass[10pt,a4paper]{article}
\usepackage{a4wide}
\usepackage{listings}
\title{Assignment 1}
\author{Danilo Carvalho Martins\\ 155123}

\begin{document}
\maketitle
\section{}
\subsection{}
The flag \verb|-c| specificies the number of packets to be sent during program
execution. The result of running \verb|ping -c 10 www.cam.ac.uk| can be seen
below:

\begin{lstlisting}
PING www.cam.ac.uk (131.111.150.25) 56(84) bytes of data.
64 bytes from primary.admin.cam.ac.uk (131.111.150.25): icmp\_seq=1 ttl=41 time=203 ms
64 bytes from primary.admin.cam.ac.uk (131.111.150.25): icmp\_seq=2 ttl=41 time=227 ms
64 bytes from primary.admin.cam.ac.uk (131.111.150.25): icmp\_seq=3 ttl=41 time=251 ms
64 bytes from primary.admin.cam.ac.uk (131.111.150.25): icmp\_seq=4 ttl=41 time=276 ms
64 bytes from primary.admin.cam.ac.uk (131.111.150.25): icmp\_seq=5 ttl=41 time=199 ms
64 bytes from primary.admin.cam.ac.uk (131.111.150.25): icmp\_seq=6 ttl=41 time=229 ms
64 bytes from primary.admin.cam.ac.uk (131.111.150.25): icmp\_seq=7 ttl=41 time=244 ms
64 bytes from primary.admin.cam.ac.uk (131.111.150.25): icmp\_seq=8 ttl=41 time=267 ms
64 bytes from primary.admin.cam.ac.uk (131.111.150.25): icmp\_seq=9 ttl=41 time=188 ms
64 bytes from primary.admin.cam.ac.uk (131.111.150.25): icmp\_seq=10 ttl=41 time=211 ms

--- www.cam.ac.uk ping statistics ---
10 packets transmitted, 10 received, 0\% packet loss, time 9003ms
rtt min/avg/max/mdev = 188.594/230.173/276.154/28.072 ms
\end{lstlisting}

From this command, we can see that the Round Trip Time(rtt) has values:

\begin{itemize}
\item Max: 276ms
\item Avg: 230ms
\item Min: 188ms
\end{itemize}

\subsection{}

The result of pinging Unicamp:

\begin{lstlisting}
PING cerejeira.unicamp.br (143.106.10.174) 56(84) bytes of data.
64 bytes from cerejeira.unicamp.br (143.106.10.174): icmp\_seq=1 ttl=50 time=192 ms
64 bytes from cerejeira.unicamp.br (143.106.10.174): icmp\_seq=2 ttl=50 time=228 ms
64 bytes from cerejeira.unicamp.br (143.106.10.174): icmp\_seq=3 ttl=50 time=252 ms
64 bytes from cerejeira.unicamp.br (143.106.10.174): icmp\_seq=4 ttl=50 time=198 ms
64 bytes from cerejeira.unicamp.br (143.106.10.174): icmp\_seq=5 ttl=50 time=200 ms
64 bytes from cerejeira.unicamp.br (143.106.10.174): icmp\_seq=6 ttl=50 time=216 ms
64 bytes from cerejeira.unicamp.br (143.106.10.174): icmp\_seq=7 ttl=50 time=239 ms
64 bytes from cerejeira.unicamp.br (143.106.10.174): icmp\_seq=8 ttl=50 time=197 ms
64 bytes from cerejeira.unicamp.br (143.106.10.174): icmp\_seq=9 ttl=50 time=285 ms
64 bytes from cerejeira.unicamp.br (143.106.10.174): icmp\_seq=10 ttl=50 time=207 ms

--- cerejeira.unicamp.br ping statistics ---
10 packets transmitted, 10 received, 0\% packet loss, time 9009ms
rtt min/avg/max/mdev = 192.424/221.909/285.132/28.196 ms
\end{lstlisting}

\begin{itemize}
\item Max: 288ms
\item Avg: 221ms
\item Min: 192ms
\end{itemize}

Since I'm currently in the East Coast of the USA, and within the same
distance to England and Campinas, the RTTs are roughly equal.

\subsection{}

We cannot ping the server, however, the webpage is reachable through TCP. This
means that the network is blocking ICMP packets, this widespread pratic renders
ping unreliable for checking reachability across the internet.

\section{}

Executing ifconfig without parameters returns:

\begin{lstlisting}
lo: flags=73<UP,LOOPBACK,RUNNING>  mtu 65536
        inet 127.0.0.1  netmask 255.0.0.0
        inet6 ::1  prefixlen 128  scopeid 0x10<host>
        loop  txqueuelen 0  (Local Loopback)
        RX packets 0  bytes 0 (0.0 B)
        RX errors 0  dropped 0  overruns 0  frame 0
        TX packets 0  bytes 0 (0.0 B)
        TX errors 0  dropped 0 overruns 0  carrier 0  collisions 0

wlp1s0: flags=4163<UP,BROADCAST,RUNNING,MULTICAST>  mtu 1500
        inet 192.168.1.128  netmask 255.255.255.0  broadcast 192.168.1.255
        inet6 fe80::d9d8:c73b:60dc:58e5  prefixlen 64  scopeid 0x20<link>
        inet6 2601:647:4601:60f8:518b:6fd5:ef07:8695  prefixlen 64  scopeid 0x0<global>
        inet6 fdef:1ae0:ee5b:0:4780:15a0:d870:3be2  prefixlen 64  scopeid 0x0<global>
        ether <redacted>  txqueuelen 1000  (Ethernet)
        RX packets 466947  bytes 698285815 (665.9 MiB)
        RX errors 0  dropped 0  overruns 0  frame 0
        TX packets 102069  bytes 9608036 (9.1 MiB)
        TX errors 0  dropped 0 overruns 0  carrier 0  collisions 0
\end{lstlisting}

We can see that there are 2 interfaces, \verb|loopback| and \verb|wlp1s0|. It
responds to the following IPs:
\begin{itemize}
\item IPv4: 127.0.0.1
\item IPv4: 192.168.1.128
\item IPv6: fe80::d9d8:c73b:60dc:58e5
\item IPv6: 2601:647:4601:60f8:518b:6fd5:ef07:8695
\item IPv6: fdef:1ae0:ee5b:0:4780:15a0:d870:3be2
\end{itemize}

Analysing the output, we can see that \verb|loopback| handled no packet and
\verb|wlp1s0| received 698285815 bytes and sent 9608036 bytes.

\section{}
After sending 2 pings to the loopback, ifconfig lo returns:

\begin{lstlisting}
lo: flags=73<UP,LOOPBACK,RUNNING>  mtu 65536
        inet 127.0.0.1  netmask 255.0.0.0
        inet6 ::1  prefixlen 128  scopeid 0x10<host>
        loop  txqueuelen 0  (Local Loopback)
        RX packets 4  bytes 336 (336.0 B)
        RX errors 0  dropped 0  overruns 0  frame 0
        TX packets 4  bytes 336 (336.0 B)
        TX errors 0  dropped 0 overruns 0  carrier 0  collisions 0
\end{lstlisting}

Thus, we can see 4 packets being handled, 2 copies(because it sends and
receives) an ICMP \verb|ECHO Request| and \verb|ECHO Reply|.

\section{}
Running \verb|route| with no parameters returns:

\begin{lstlisting}
Kernel IP routing table
Destination     Gateway         Genmask         Flags Metric Ref    Use Iface
default         gateway         0.0.0.0         UG    302    0        0 wlp1s0
192.168.1.0     *               255.255.255.0   U     302    0        0 wlp1s0
\end{lstlisting}

Showing two defined routes. The interface of the default reoute is wlp1s0.

\section{}
\subsection{}

Executing \verb|nslookup www.google.com| returns:

\begin{lstlisting}
Server:		8.8.8.8
Address:	8.8.8.8#53

Non-authoritative answer:
Name:	www.google.com
Address: 172.217.3.36
\end{lstlisting}

It says that \verb|www.google.com| is at \verb|172.217.3.36|. There is
advantages of having mutiple in having multiple IP addresses, higher
reachability being one of those. However, Google has chosen not to advertise
multiple addresses for this domain, most likely because it's using anycast in
partnership with the ISP and sending the address of the closes edge server.
My computer primary DNS server is \verb|8.8.8.8|, Google's public DNS.

\subsection{}
That address is the \verb|localhost|, an address that references the computer
itself.

\section{}
\subsection{}

After running \verb|traceroute www.google.com|:

\begin{lstlisting}
traceroute to www.google.com (172.217.2.36), 30 hops max, 60 byte packets
 1  gateway (192.168.1.1)  1.695 ms  2.345 ms  3.931 ms
 2  96.120.89.221 (96.120.89.221)  14.365 ms  19.596 ms  20.600 ms
 3  te-0-2-0-11-sur04.santaclara.ca.sfba.comcast.net (162.151.30.133)  21.756 ms  22.144 ms  21.761 ms
 4  hu-0-3-0-4-ar01.hayward.ca.sfba.comcast.net (68.87.192.241)  22.151 ms
    hu-0-3-0-6-ar01.hayward.ca.sfba.comcast.net (68.87.192.249)  22.319 ms
    hu-0-3-0-4-ar01.hayward.ca.sfba.comcast.net (68.87.192.241)  25.940 ms
 5  he-0-19-0-0-ar01.santaclara.ca.sfba.comcast.net (68.85.154.253)  27.615 ms
    hu-0-0-0-0-ar01.santaclara.ca.sfba.comcast.net (68.85.154.249)  27.072 ms
    hu-0-0-0-1-ar01.santaclara.ca.sfba.comcast.net (68.85.57.145)  26.639 ms
 6  * * *
 7  he-0-11-0-1-pe02.529bryant.ca.ibone.comcast.net (68.86.86.146)  26.465 ms  12.676 ms  14.057 ms
 8  66.208.228.70 (66.208.228.70)  18.738 ms  21.866 ms  17.758 ms
 9  72.14.232.138 (72.14.232.138)  22.269 ms  22.271 ms  21.788 ms
10  66.249.95.31 (66.249.95.31)  21.808 ms  21.805 ms  21.794 ms
11  nuq05s02-in-f4.1e100.net (172.217.2.36)  21.774 ms  21.770 ms  22.875 ms
\end{lstlisting}

By the count on the left side, there are 11 IP routers between myself and
\verb|www.google.com|. Since I'm not in Brazil, I'm going to answer the second
part as the number of routers inside Comcast's network: 7(considering myself and
my router inside their network), 7's address looks like an edge router's and is
the last one identified by comcast itself.

\subsection{}

Running \verb|traceroute -T home.pl|(using TCP to show a
little more of comcast's network we get:
\begin{lstlisting}
traceroute to home.pl (212.85.96.1), 30 hops max, 60 byte packets
 1  gateway (192.168.1.1)  6.334 ms  6.424 ms  9.640 ms
 2  96.120.89.221 (96.120.89.221)  20.446 ms  23.893 ms  26.740 ms
 3  te-0-2-0-11-sur04.santaclara.ca.sfba.comcast.net (162.151.30.133)  27.340 ms  28.478 ms  29.484 ms
 4  hu-0-3-0-7-ar01.hayward.ca.sfba.comcast.net (68.87.192.253)  30.513 ms
    hu-0-3-0-6-ar01.hayward.ca.sfba.comcast.net (68.87.192.249)  34.938 ms
    hu-0-3-0-4-ar01.hayward.ca.sfba.comcast.net (68.87.192.241)  36.071 ms
 5  4.68.127.109 (4.68.127.109)  36.297 ms  36.918 ms  40.975 ms
 6  ae-1-9.bar1.Warsaw1.Level3.net (4.69.153.70)  214.496 ms  185.949 ms  198.239 ms
 7  LWLcom-Bremen.level3.net (213.242.117.58)  198.605 ms  185.473 ms  190.288 ms
 8  * * *
 9  home.pl (212.85.96.1)  190.730 ms  185.850 ms  186.042 ms
\end{lstlisting}

We cannot know exactly the path because the next hop from Level3, presumably in 
Bremen is dropping the ICMP timeouts that would be used to determine the path.
However, its enough to see, comparing from the output below from home.pl, that
the packets in different directions do not use the same path. In fact, from
previous traceroutes it can be seen that there are some hops with multiple
addresses, that correspond to different routing decisions by the edge network.

\begin{lstlisting}
HOST: vmy1.home.net.pl            Loss%   Snt   Last   Avg  Best  Wrst StDev
  1.|-- 2a02:25a8:1::5e            0.0%     5    0.5   0.5   0.5   0.6   0.1
  2.|-- 2a02:25a8:ffff:ffff:ffff:  0.0%     5   28.6  37.1   0.6  63.3  24.7
  3.|-- xe-11-2-0-182.bar1.Warsaw  0.0%     5    0.7   0.7   0.7   0.8   0.0
  4.|-- ae-1-4050-v6.edge3.Frankf  0.0%     5   29.4  29.5  29.4  29.6   0.1
  5.|-- vl-4060.edge4.Paris1.Leve  0.0%     5   38.2  38.3  38.2  38.3   0.0
  6.|-- vl-4081.edge3.Paris1.Leve  0.0%     5   38.3  38.3  38.2  38.4   0.1
  7.|-- vl-4086.edge1.Washington1  0.0%     5  115.9 117.4 115.8 123.8   3.6
  8.|-- vl-4081.edge2.Washington1  0.0%     5  115.8 115.8 115.8 115.8   0.0
  9.|-- 2001:1900:4:1::4ad         0.0%     5  123.3 122.1 121.8 123.3   0.7
 10.|-- vl-4040.edge1.SanJose1.Le  0.0%     5  189.8 189.8 189.7 189.9   0.1
 11.|-- vl-70.ear1.SanJose1.Level  0.0%     5  189.8 189.8 189.7 189.9   0.0
 12.|-- 2001:1900:4:3::3da         0.0%     5  190.0 190.0 189.9 190.1   0.1
 13.|-- hu-0-1-0-0-sur03.santacla  0.0%     5  189.8 189.9 189.8 190.0   0.1
 14.|-- te-6-0-acr07.santaclara.c  0.0%     5  190.1 190.1 190.1 190.2   0.1
 15.|-- 2001:558:6045:b0:5841:2f8  0.0%     5  200.7 200.2 199.9 200.7   0.4
 16.|-- ???                       100.0     5    0.0   0.0   0.0   0.0   0.0
\end{lstlisting}

\subsection{}

We have enough output to see that hop 6 is is europe, from the sudden jump in
latency, 30ms to 180ms and from the name of the routers(Warsaw and Bremen).


\section{}
\subsection{}

Running \verb|netstat -tu| wields:

\begin{lstlisting}
Active Internet connections (w/o servers)
Proto Recv-Q Send-Q Local Address           Foreign Address         State      
tcp        0      0 localhost:49486         cerejeira.unic:www-http ESTABLISHED
tcp        0      0 localhost:49500         cerejeira.unic:www-http ESTABLISHED
tcp        0      0 localhost:35914         72.21.91.29:www-http    ESTABLISHED
tcp        0      0 localhost:49492         cerejeira.unic:www-http ESTABLISHED
tcp        0      0 localhost:44378         server-52-84-236-:https ESTABLISHED
tcp        0      0 localhost:49494         cerejeira.unic:www-http ESTABLISHED
tcp        0      0 localhost:49496         cerejeira.unic:www-http ESTABLISHED
tcp        0      0 localhost:49488         cerejeira.unic:www-http ESTABLISHED
tcp        0      0 localhost:49498         cerejeira.unic:www-http ESTABLISHED
\end{lstlisting}

We can see the protocol being used, the the local address and port, the server
address and port and the connection state.

\subsection{}

There are additional connections to 72.21.91.29 on port 80 and server-52-84-236
(truncated by netstat) on port 443. They are most likely the servers that serve
http libraries for the www.unicamp.br. The ports for the same (ip:port) tuple
seems to be somewhat sequential, with (ip:port) tuples for different services
being somewhat random.

\section 8.1

Yes, you can connect to \verb|google.com| as telnet google.com 80. If there
isn't a server listening, there's two options, it might ignore the request,
resulting in a timeout(\verb|telnet google.com 23|) or it might return a RST
resulting in \verb|Connection refused|(\verb|telnetl localhost 80|). To accept
connections to port 80 we need something listening on that port
(\verb|sudo nc -l 80|), for instance

\end{document}

